#include "dos.h"

typedef unsigned char byte;

const int XPixels = 320;
const int YPixels = 200;
const int MaxIter = 150;

const double XMin   = -0.64L;
const double XMax   = -0.44L;
const double YMin   =  0.55L;
const double YMax   =  0.70L;
const double Escape =  4.0L;

double Xval[XPixels];

int main()
    {
    const double DeltaX = (XMax - XMin) / (double)XPixels;
    const double DeltaY = (YMax - YMin) / (double)YPixels;

    double RowVal, X, Y, Xsq, Ysq, Xv;

    int color, row, col;

    union REGS r;

    byte __far * gmem = (byte __far *)(0xA0000000);

    r.x.ax = 0x0013;
    int86(0x10,&r,&r);

    // precalculate increments along Y-axis
    Xval[0] = XMin;

    for (col = 1; col < XPixels; ++col)
        Xval[col] = Xval[col - 1] + DeltaX;

    RowVal = YMax;

    // calculate and display Mandelbrot set
    for (row = 0; row < YPixels; ++row)
        {
        for (col = 0; col < XPixels; ++col)
            {
            X   = 0.0L;
            Y   = 0.0L;
            Xsq = 0.0L;
            Ysq = 0.0L;

            Xv  = Xval[col];

            color = 0;

            while (color < MaxIter)
                {
                Xsq  = X * X;
                Ysq  = Y * Y;

                if ((Xsq + Ysq) >= Escape)
                    break;

                Y   *= X;
                Y   += Y + RowVal;
                X    = Xsq - Ysq + Xv;

                ++color;
                }

            if (color == MaxIter)
                *gmem = 0;
            else
                *gmem = (color & 15) + 1;

            ++gmem;
            }

        RowVal -= DeltaY;
        }

    r.x.ax = 0x0003;
    int86(0x10,&r,&r);

    return 0;
    }
